<html>
<head>
	<title>Skutki uboczne szczepionek</title>
	 <link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
   integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
   crossorigin=""/>
    <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"
   integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA=="
   crossorigin=""></script>
	<script src="wojewodztwa-max.geojson"></script>
	<script src="data.js"></script>
<body>
<style>
#map { 
		height: 800px;
}
#canvas {}
</style>
<div id="map"></div>
<canvas id="canvas">
</canvas>
<script>
var map = L.map('map').setView([52.52,13.40], 7, );
map.touchZoom.disable();
map.doubleClickZoom.disable();
map.scrollWheelZoom.disable();
map.boxZoom.disable();
map.keyboard.disable();
L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token={accessToken}', {
    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
    maxZoom: 18,
    id: 'mapbox/streets-v11',
    tileSize: 512,
    zoomOffset: -1,
    accessToken: 'pk.eyJ1Ijoia2Fyb2wyMjEtMTAiLCJhIjoiY2t3dDg0OGFuMWRxajJvcW94N3ExdmNteiJ9.hPQbnIAvS7ylVB7m4RDjFg'
}).addTo(map);
var geojsonLayer = L.geoJson(wojewodztwa);
geojsonLayer.addTo(map);
</script>
<script>
	function drawEllipse(ctx, x, y, w, h) {
		var kappa = .5522848,
				ox = (w / 2) * kappa, // control point offset horizontal
				oy = (h / 2) * kappa, // control point offset vertical
				xe = x + w,           // x-end
				ye = y + h,           // y-end
				xm = x + w / 2,       // x-middle
				ym = y + h / 2;       // y-middle

		ctx.beginPath();
		ctx.moveTo(x, ym);
		ctx.bezierCurveTo(x, ym - oy, xm - ox, y, xm, y);
		ctx.bezierCurveTo(xm + ox, y, xe, ym - oy, xe, ym);
		ctx.bezierCurveTo(xe, ym + oy, xm + ox, ye, xm, ye);
		ctx.bezierCurveTo(xm - ox, ye, x, ym + oy, x, ym);
		//ctx.closePath(); // not used correctly, see comments (use to close off open path)
		ctx.stroke();
		ctx.fillStyle = "white";
		ctx.fill();
	}
</script>
<script>
	var canvas = document.getElementById("canvas");
	canvas.width = 400;
	canvas.height = 400;
	var ctx = canvas.getContext("2d");
	function drawFace(age) {
		var height = 0;
		switch(age) {
			case 'young':
				height = 70;
				break
			case 'middle':
				height = 90;
				break;
			case 'old':
				height = 120;
				break;
		}
		drawEllipse(ctx, 50, 60, 100, height);
	}
	function drawDose(dose, age) {
		var xpos = 60;
		var ypos = 70;
		var offset;
		switch(age) {
			case 'young':
				xpos = 50;
				ypos = 70;
				offset = 100;
			break;
			case 'middle':
				xpos = 45;
				ypos = 80;
				offset = 110;
			break;
			case 'old':
				xpos = 44;
				ypos = 90;
				offset = 112;
			break;
		}
		if(dose === 0) {
			ctx.beginPath();
			ctx.arc(xpos, ypos, 10, 0, 2 * Math.PI);
			ctx.stroke();
			ctx.stroke();
			ctx.fillStyle = "white";
			ctx.fill();
		}
		if(dose === 1) {
			ctx.beginPath();
			ctx.arc(xpos, ypos, 10, 0, 2 * Math.PI);
			ctx.stroke();
			ctx.stroke();
			ctx.fillStyle = "white";
			ctx.fill();
			ctx.beginPath();
			ctx.arc(xpos + offset, ypos, 10, 0, 2 * Math.PI);
			ctx.stroke();
			ctx.stroke();
			ctx.fillStyle = "white";
			ctx.fill();
		}
	}
	function drawSex(sex) {
		var xPos = 70;
		var yPos = 33;
		var sexOffset = 0;
		switch(sex) {
			case 'M':
				sexOffset = 20;
			break;
			case 'W':
				sexOffset = -20;
			break;
		}
		ctx.beginPath();
		ctx.moveTo(xPos - 5,yPos - sexOffset);
		ctx.lineTo(xPos + 30,yPos + 28);
		ctx.moveTo(xPos - 10,yPos - sexOffset + 10);
		ctx.lineTo(xPos + 30,yPos + 28);
		ctx.moveTo(xPos + 60,yPos - sexOffset);
		ctx.lineTo(xPos + 30,yPos + 28);
		ctx.moveTo(xPos + 80,yPos - sexOffset);
		ctx.lineTo(xPos + 30,yPos + 28);
		ctx.stroke();
	}
	function drawHospitalization(hospitalization, age) {
		var xPos;
		var yPos;
		var offset = 0;
		var startOffset = 0;
		switch(age) {
			case "old":
				xPos = 80;
				yPos = 150;
				offset = -10;
				startOffset = 10;
			break;
			case "middle":
				xPos = 80;
				yPos = 130;
				offset = -30;
				startOffset = 10;
			break;
			case "young":
				xPos = 80;
				yPos = 110;
				offset = -50;
				startOffset = 10;
			break;
		}
		if (hospitalization === true) {
			ctx.beginPath();
			ctx.moveTo(xPos, yPos);
			ctx.bezierCurveTo(70, 130 + offset, 130, 130 + offset, 120, 160 + offset);
			ctx.stroke();
		}
		else {
			ctx.beginPath();
			ctx.moveTo(xPos, yPos - startOffset);
			ctx.bezierCurveTo(90, 200 + offset , 130, 150 + offset, 120 , 150 + offset);
			ctx.stroke();
		}

	}
	function drawDoseType(doseType, age) {
		var yOffset = 0;
		var doseOffset = 0;
		switch(age) {
			case 'middle':
				yOffset = 10;
			break;
			case 'old':
				yOffset = 30;
			break;
		}
		if(doseType === 'Pfizer') {
			doseOffset = -5;
		}
		if(doseType === 'Moderna') {
			doseOffset = 10;
		}
		ctx.beginPath();
		ctx.arc(80 - doseOffset, 75 + yOffset, 5, 0, 2 * Math.PI);
		ctx.stroke();
		ctx.beginPath();
		ctx.arc(80 - doseOffset, 75 + yOffset, 2.5, 0, 2 * Math.PI);
		ctx.stroke();
		ctx.beginPath();
		ctx.arc(120 + doseOffset, 75 + yOffset, 5, 0, 2 * Math.PI);
		ctx.stroke();
		ctx.beginPath();
		ctx.arc(120 + doseOffset, 75 + yOffset, 2.5, 0, 2 * Math.PI);
		ctx.stroke();
	}
	var pngs = [];
	for(let i = 0; i < data.length; i++) {
		ctx.clearRect(0, 0, canvas.width, canvas.height);
		var age = data[i].age;
		drawFace(age);
		drawDose(data[i].dose, age);
		drawSex(data[i].sex);
		drawHospitalization(data[i].hospitalization, age);
		drawDoseType(data[i].doseType, age);
		pngs.push({
			png: canvas.toDataURL(),
			posX: data[i].posX,
			posY: data[i].posY
		});
	}
</script>
<script>
	for(let i = 0; i<pngs.length; i++) {
		let icon = L.icon({
			iconUrl: pngs[i].png,
			iconSize:     [200, 200], // size of the icon
			iconAnchor:   [0, 0], // point of the icon which will correspond to marker's location
			popupAnchor:  [0, 0] // point from which the popup should open relative to the iconAnchor
		});
		L.marker([pngs[i].posX, pngs[i].posY], {icon: icon}).addTo(map);
	}
</script>
</body>
</html>